=== debian/changelog ===
lv2 (1.18.0-1) unstable; urgency=medium

  [ Olivier Humbert ]
  * d/copyright: https -> https

  [ Dennis Braun ]
  * New upstream version 1.18.0
  * Bump S-V to 4.5.0
  * Bump dh-compat to 13
  * Mark lv2-dev as Multi-Arch: same
  * Add me as uploader
  * Update d/copyright year
  * Use https protocol for the source url
  * Use https protocol for the homepage url
  * Add d/not-installed
  * Add d/upstream/metadata
  * Update d/watch to check signing

 -- Dennis Braun <d_braun@kabelmail.de>  Fri, 08 May 2020 22:31:46 +0200
