## lv2 1.18.2

=== wscript ===
#!/usr/bin/env python

import os
import re
import sys

from waflib import Build, Context, Logs, Options, Scripting, Utils
from waflib.extras import autowaf as autowaf

# Mandatory waf variables
APPNAME = 'lv2'     # Package name for waf dist
VERSION = '1.18.2'  # Package version for waf dist
top     = '.'       # Source directory
out     = 'build'   # Build directory

# Release variables
title        = 'LV2'
uri          = 'http://lv2plug.in/ns/lv2'
dist_pattern = 'http://lv2plug.in/spec/lv2-%d.%d.%d.tar.bz2'
post_tags    = []

# Links for documentation
list_email = 'devel@lists.lv2plug.in'
list_page  = 'http://lists.lv2plug.in/listinfo.cgi/devel-lv2plug.in'

# Map of specification base name to old URI-style include path
spec_map = {
    'atom':            'lv2/lv2plug.in/ns/ext/atom',
    'buf-size':        'lv2/lv2plug.in/ns/ext/buf-size',
    'core':            'lv2/lv2plug.in/ns/lv2core',
    'data-access':     'lv2/lv2plug.in/ns/ext/data-access',
    'dynmanifest':     'lv2/lv2plug.in/ns/ext/dynmanifest',
    'event':           'lv2/lv2plug.in/ns/ext/event',
    'instance-access': 'lv2/lv2plug.in/ns/ext/instance-access',
    'log':             'lv2/lv2plug.in/ns/ext/log',
    'midi':            'lv2/lv2plug.in/ns/ext/midi',
    'morph':           'lv2/lv2plug.in/ns/ext/morph',
    'options':         'lv2/lv2plug.in/ns/ext/options',
    'parameters':      'lv2/lv2plug.in/ns/ext/parameters',
    'patch':           'lv2/lv2plug.in/ns/ext/patch',
    'port-groups':     'lv2/lv2plug.in/ns/ext/port-groups',
    'port-props':      'lv2/lv2plug.in/ns/ext/port-props',
    'presets':         'lv2/lv2plug.in/ns/ext/presets',
    'resize-port':     'lv2/lv2plug.in/ns/ext/resize-port',
    'state':           'lv2/lv2plug.in/ns/ext/state',
    'time':            'lv2/lv2plug.in/ns/ext/time',
    'ui':              'lv2/lv2plug.in/ns/extensions/ui',
    'units':           'lv2/lv2plug.in/ns/extensions/units',
    'uri-map':         'lv2/lv2plug.in/ns/ext/uri-map',
    'urid':            'lv2/lv2plug.in/ns/ext/urid',
    'worker':          'lv2/lv2plug.in/ns/ext/worker'}


def options(ctx):
    ctx.load('compiler_c')
    ctx.load('compiler_cxx')
    ctx.load('lv2')
    ctx.add_flags(
        ctx.configuration_options(),
        {'no-coverage':    'Do not use gcov for code coverage',
         'online-docs':    'Build documentation for web hosting',
         'no-check-links': 'Do not check documentation for broken links',
         'no-plugins':     'Do not build example plugins',
         'copy-headers':   'Copy headers instead of linking to bundle'})


def configure(conf):
    try:
        conf.load('compiler_c', cache=True)
    except Exception:
        Options.options.build_tests = False
        Options.options.no_plugins = True

    try:
        conf.load('compiler_cxx', cache=True)
    except Exception:
        pass

    if Options.options.online_docs:
        Options.options.docs = True

    conf.load('lv2', cache=True)
    conf.load('autowaf', cache=True)
    autowaf.set_c_lang(conf, 'c99')

    if Options.options.strict:
        # Check for programs used by lint target
        conf.find_program("flake8", var="FLAKE8", mandatory=False)
        conf.find_program("clang-tidy", var="CLANG_TIDY", mandatory=False)
        conf.find_program("iwyu_tool", var="IWYU_TOOL", mandatory=False)

    if Options.options.ultra_strict:
        autowaf.add_compiler_flags(conf.env, 'c', {
            'gcc': [
                '-Wno-bad-function-cast',
            ],
            'clang': [
                '-Wno-bad-function-cast',
            ]
        })

        autowaf.add_compiler_flags(conf.env, '*', {
            'clang': [
                '-Wno-cast-align',
                '-Wno-cast-qual',
                '-Wno-documentation-unknown-command',
                '-Wno-double-promotion',
                '-Wno-float-conversion',
                '-Wno-float-equal',
                '-Wno-implicit-float-conversion',
                '-Wno-padded',
                '-Wno-reserved-id-macro',
                '-Wno-shorten-64-to-32',
                '-Wno-sign-conversion',
                '-Wno-switch-enum',
                '-Wno-unused-parameter',
            ],
            'gcc': [
                '-Wno-cast-align',
                '-Wno-cast-qual',
                '-Wno-conversion',
                '-Wno-double-promotion',
                '-Wno-float-equal',
                '-Wno-inline',
                '-Wno-padded',
                '-Wno-parentheses',
                '-Wno-suggest-attribute=const',
                '-Wno-suggest-attribute=malloc',
                '-Wno-suggest-attribute=pure',
                '-Wno-switch-enum',
                '-Wno-unused-parameter',
            ],
            'msvc': [
                '/wd4061',  # enumerator in switch is not explicitly handled
                '/wd4100',  # unreferenced formal parameter
                '/wd4244',  # conversion with possible loss of data
                '/wd4267',  # conversion from size_t to a smaller type
                '/wd4310',  # cast truncates constant value
                '/wd4365',  # signed/unsigned mismatch
                '/wd4464',  # relative include path contains ".."
                '/wd4514',  # unreferenced inline function has been removed
                '/wd4706',  # assignment within conditional expression
                '/wd4710',  # function not inlined
                '/wd4711',  # function selected for automatic inline expansion
                '/wd4820',  # padding added after construct
                '/wd5045',  # will insert Spectre mitigation for memory load
            ]
        })

        autowaf.add_compiler_flags(conf.env, 'cxx', {
            'gcc': [
                '-Wno-useless-cast',
                '-Wno-zero-as-null-pointer-constant',
            ],
            'clang': [
                '-Wno-old-style-cast',
                '-Wno-zero-as-null-pointer-constant',
            ]
        })

        if 'mingw' in conf.env.CC[0]:
            autowaf.add_compiler_flags(conf.env, '*', {
                'gcc': [
                    '-Wno-format',
                    '-Wno-suggest-attribute=format',
                ],
            })

    if conf.env.DEST_OS == 'win32' or not hasattr(os.path, 'relpath'):
        Logs.warn('System does not support linking headers, copying')
        Options.options.copy_headers = True

    conf.env.BUILD_TESTS   = Options.options.build_tests
    conf.env.BUILD_PLUGINS = not Options.options.no_plugins
    conf.env.COPY_HEADERS  = Options.options.copy_headers
    conf.env.ONLINE_DOCS   = Options.options.online_docs

    if conf.env.DOCS or conf.env.ONLINE_DOCS:
        try:
            conf.find_program('asciidoc')
            conf.env.BUILD_BOOK = True
        except Exception:
            Logs.warn('Asciidoc not found, book will not be built')

        if not Options.options.no_check_links:
            if not conf.find_program('linkchecker',
                                     var='LINKCHECKER', mandatory=False):
                Logs.warn('Documentation will not be checked for broken links')

    # Check for gcov library (for test coverage)
    if (conf.env.BUILD_TESTS and
        not Options.options.no_coverage and
        not conf.is_defined('HAVE_GCOV')):
        conf.check_cc(lib='gcov', define_name='HAVE_GCOV', mandatory=False)

    if conf.env.BUILD_TESTS:
        conf.find_program('serdi', mandatory=False)
        conf.find_program('sord_validate', mandatory=False)

    autowaf.set_lib_env(conf, 'lv2', VERSION, has_objects=False)
    autowaf.set_local_lib(conf, 'lv2', has_objects=False)

    conf.run_env.append_unique('LV2_PATH',
                               [os.path.join(conf.path.abspath(), 'lv2')])

    if conf.env.BUILD_PLUGINS:
        for i in ['eg-amp.lv2',
                  'eg-fifths.lv2',
                  'eg-metro.lv2',
                  'eg-midigate.lv2',
                  'eg-params.lv2',
                  'eg-sampler.lv2',
                  'eg-scope.lv2']:
            try:
                path = os.path.join('plugins', i)
                conf.recurse(path)
                conf.env.LV2_BUILD += [path]
                conf.run_env.append_unique(
                    'LV2_PATH', [conf.build_path('plugins/%s/lv2' % i)])
            except Exception as e:
                Logs.warn('Configuration of %s failed (%s)' % (i, e))

    autowaf.display_summary(
        conf,
        {'Bundle directory': conf.env.LV2DIR,
         'Copy (not link) headers': bool(conf.env.COPY_HEADERS),
         'Version': VERSION})


def chop_lv2_prefix(s):
    if s.startswith('lv2/lv2plug.in/'):
        return s[len('lv2/lv2plug.in/'):]
    return s


def subst_file(template, output, dict):
    i = open(template, 'r')
    o = open(output, 'w')
    for line in i:
        for key in dict:
            line = line.replace(key, dict[key])
        o.write(line)
    i.close()
    o.close()


def specdirs(path):
    return (path.ant_glob('lv2/*', dir=True) +
            path.ant_glob('plugins/*.lv2', dir=True))


def ttl_files(path, specdir):
    def abspath(node):
        return node.abspath()

    return map(abspath,
               path.ant_glob(specdir.path_from(path) + '/*.ttl'))


def load_ttl(files, exclude = []):
    import rdflib
    model = rdflib.ConjunctiveGraph()
    for f in files:
        if f not in exclude:
            model.parse(f, format='n3')
    return model


# Task to build extension index
def build_index(task):
    src_dir = task.inputs[0].parent.parent
    sys.path.append(str(src_dir.find_node('lv2specgen')))
    import rdflib

    doap = rdflib.Namespace('http://usefulinc.com/ns/doap#')

    model = load_ttl([str(src_dir.find_node('lv2/core/meta.ttl')),
                      str(src_dir.find_node('lv2/core/people.ttl'))])

    # Get date for this version, and list of all LV2 distributions
    proj  = rdflib.URIRef('http://lv2plug.in/ns/lv2')
    date  = None
    dists = []
    for r in model.triples([proj, doap.release, None]):
        revision = model.value(r[2], doap.revision, None)
        created  = model.value(r[2], doap.created, None)
        if str(revision) == VERSION:
            date = created

        dist = model.value(r[2], doap['file-release'], None)
        if dist and created:
            dists += [(created, dist)]
        else:
            print('warning: %s has no file release\n' % proj)

    rows = []
    for f in task.inputs:
        if not f.abspath().endswith('index.html.in'):
            rowfile = open(f.abspath(), 'r')
            rows += rowfile.readlines()
            rowfile.close()

    if date is None:
        import datetime
        import time
        now = int(os.environ.get('SOURCE_DATE_EPOCH', time.time()))
        date = datetime.datetime.utcfromtimestamp(now).strftime('%F')

    subst_file(task.inputs[0].abspath(), task.outputs[0].abspath(),
               {'@ROWS@': ''.join(rows),
                '@LV2_VERSION@': VERSION,
                '@DATE@': date})


def build_spec(bld, path):
    name            = os.path.basename(path)
    bundle_dir      = os.path.join(bld.env.LV2DIR, name + '.lv2')
    include_dir     = os.path.join(bld.env.INCLUDEDIR, path)
    old_include_dir = os.path.join(bld.env.INCLUDEDIR, spec_map[name])

    # Build test program if applicable
    for test in bld.path.ant_glob(os.path.join(path, '*-test.c')):
        test_lib       = []
        test_cflags    = ['']
        test_linkflags = ['']
        if bld.is_defined('HAVE_GCOV'):
            test_lib       += ['gcov']
            test_cflags    += ['--coverage']
            test_linkflags += ['--coverage']
            if bld.env.DEST_OS not in ['darwin', 'win32']:
                test_lib += ['rt']

        # Unit test program
        bld(features     = 'c cprogram',
            source       = test,
            lib          = test_lib,
            uselib       = 'LV2',
            target       = os.path.splitext(str(test.get_bld()))[0],
