=== debian/changelog ===
lv2 (1.18.2-1~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 17 Jun 2023 10:43:34 -0700

lv2 (1.18.2-1) unstable; urgency=medium

  [ Olivier Humbert ]
  * d/lv2-dev.install: installs lv2_validate
  * d/not-installed: lv2_validate is installed now
  * d/control: removal of the reference to lv2specgen

  [ Dennis Braun ]
  * New upstream version 1.18.2
  * Bump S-V to 4.5.1

 -- Dennis Braun <d_braun@kabelmail.de>  Sun, 17 Jan 2021 21:56:59 +0100
