## lv2 1.18.4

=== wscript ===
--- 
+++ 
@@ -9,7 +9,7 @@
 
 # Mandatory waf variables
 APPNAME = 'lv2'     # Package name for waf dist
-VERSION = '1.18.2'  # Package version for waf dist
+VERSION = '1.18.4'  # Package version for waf dist
 top     = '.'       # Source directory
 out     = 'build'   # Build directory
 
@@ -81,7 +81,6 @@
 
     conf.load('lv2', cache=True)
     conf.load('autowaf', cache=True)
-    autowaf.set_c_lang(conf, 'c99')
 
     if Options.options.strict:
         # Check for programs used by lint target
@@ -109,6 +108,7 @@
                 '-Wno-float-equal',
                 '-Wno-implicit-float-conversion',
                 '-Wno-padded',
+                '-Wno-poison-system-directories',
                 '-Wno-reserved-id-macro',
                 '-Wno-shorten-64-to-32',
                 '-Wno-sign-conversion',
@@ -166,6 +166,8 @@
                 ],
             })
 
+    autowaf.set_c_lang(conf, 'c99')
+
     if conf.env.DEST_OS == 'win32' or not hasattr(os.path, 'relpath'):
         Logs.warn('System does not support linking headers, copying')
         Options.options.copy_headers = True
@@ -196,6 +198,7 @@
     if conf.env.BUILD_TESTS:
         conf.find_program('serdi', mandatory=False)
         conf.find_program('sord_validate', mandatory=False)
+        conf.find_program('codespell', mandatory=False)
 
     autowaf.set_lib_env(conf, 'lv2', VERSION, has_objects=False)
     autowaf.set_local_lib(conf, 'lv2', has_objects=False)
@@ -334,5 +337,3 @@
         bld(features     = 'c cprogram',
             source       = test,
             lib          = test_lib,
-            uselib       = 'LV2',
-            target       = os.path.splitext(str(test.get_bld()))[0],
