=== plugins/eg-metro.lv2/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
import re

# Variables for 'waf dist'
APPNAME = 'eg-metro.lv2'
VERSION = '1.0.0'

# Mandatory variables
top = '.'
out = 'build'

def options(opt):
    opt.load('compiler_c')
    opt.load('lv2')
    autowaf.set_options(opt)

def configure(conf):
    conf.load('compiler_c', cache=True)
    conf.load('lv2', cache=True)
    conf.load('autowaf', cache=True)

    conf.check_pkg('lv2 >= 0.2.0', uselib_store='LV2')

    conf.check(features='c cshlib', lib='m', uselib_store='M', mandatory=False)

def build(bld):
    bundle = 'eg-metro.lv2'

    # Build manifest.ttl by substitution (for portable lib extension)
    bld(features     = 'subst',
        source       = 'manifest.ttl.in',
        target       = 'lv2/%s/%s' % (bundle, 'manifest.ttl'),
        install_path = '${LV2DIR}/%s' % bundle,
        LIB_EXT      = bld.env.LV2_LIB_EXT)

    # Copy other data files to build bundle (build/eg-metro.lv2)
    bld(features     = 'subst',
        is_copy      = True,
        source       = 'metro.ttl',
        target       = 'lv2/%s/metro.ttl' % bundle,
        install_path = '${LV2DIR}/%s' % bundle)

    # Build plugin library
    obj = bld(features     = 'c cshlib lv2lib',
              source       = 'metro.c',
              name         = 'metro',
              target       = 'lv2/%s/metro' % bundle,
              install_path = '${LV2DIR}/%s' % bundle,
              use          = ['M', 'LV2'])
