=== debian/changelog ===
lv2 (1.18.4-2) unstable; urgency=medium

  * Set --libdir to fix build on ppc64el with usrmerge build environment.
    Thanx to vorlon for this patch! (Closes: #1018248)
  * Fix FTCBFS: Export build tools for waf. Thanks to Helmut Grohne!
    (Closes: #1021036)
  * d/copyright: Fix cc-by-sa-3.0 license name

 -- Dennis Braun <d_braun@kabelmail.de>  Mon, 31 Oct 2022 13:24:40 +0100

lv2 (1.18.4-1) unstable; urgency=medium

  * New upstream version 1.18.4
  * Bump Standards Version to 4.6.1
  * Mark python3 B-D as native, trying to fix crossbuilding
  * d/copyright: Add documentation files licensed under CC-BY-SA-3
  * d/copyright: Add myself to the d/ section
  * Add salsa ci config

 -- Dennis Braun <d_braun@kabelmail.de>  Sun, 12 Jun 2022 14:12:07 +0200
