=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,9 @@
 #!/usr/bin/make -f
 # -*- makefile -*-
 
+DPKG_EXPORT_BUILDTOOLS=1
 include /usr/share/dpkg/architecture.mk
+include /usr/share/dpkg/buildtools.mk
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
 
@@ -13,6 +15,7 @@
 override_dh_auto_configure:
 	$(WAF) configure --prefix=/usr \
 		--mandir=/usr/share/man \
+		--libdir=/usr/lib \
 		--strict
 
 override_dh_auto_build:
@@ -37,7 +40,3 @@
 
 override_dh_installchangelogs:
 	dh_installchangelogs NEWS
-
-# No dbgsym packages:
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym
